<!DOCTYPE html>
<html lang="en">

<head>
	<title>67.S10</title>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
	<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

	<!-- Import Datatable sau jquery -->
	<!-- Import them style bootstrap cho datatable -->
	<link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
	<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
	<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>

	<div class="container">
		<h2 style="text-align: center;">Quản trị Voucher</h2>
		<div class="jumbotron container">
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="voucher-code">Mã Voucher</label>
				</div>
				<div class="col-sm-9">
					<input type="text" id="input-voucher-code" name="vouchercodes" placeholder="Voucher code"
						class="form-control">
				</div>
			</div>
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="discount">Phần trăm giảm giá</label>
				</div>
				<div class="col-sm-9">
					<input type="number" id="input-discount" name="discount" placeholder="Discount"
						class="form-control">
				</div>
			</div>
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="note">Ghi chú</label>
				</div>
				<div class="col-sm-9">
					<input type="text" id="input-note" name="note" placeholder="Note" class="form-control">
				</div>
			</div>
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="createDate">Ngày Tạo</label>
				</div>
				<div class="col-sm-9">
					<input type="date" id="input-createDate" name="createDate" placeholder="Create Date"
						class="form-control">
				</div>
			</div>
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="updateDate">Ngày sửa</label>
				</div>
				<div class="col-sm-9">
					<input type="date" id="input-updateDate" name="updateDate" placeholder="Update Date"
						class="form-control">
				</div>
			</div>
			<div class="row pull-right">
				<div class="col-sm-4">
					<button id="btn-add" class="btn btn-success">Thêm</button>
					<button id="btn-delete-all" class="btn btn-danger">Xóa Tất Cả</button>
				</div>
			</div>
		</div>
		<table class="table table-bordered table-striped table-hover" id="user-table">
			<thead>
				<tr>
					<th>STT</th>
					<th>Mã giảm giá</th>
					<th>Phần trăm giảm giá</th>
					<th>Ghi Chú</th>
					<th>Ngày tạo</th>
					<th>Ngày cập nhật</th>
				</tr>
		</table>
	</div>
	<!-- Modal detail-->
	<div class="modal fade" id="modal-detail" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
		aria-hidden="true">
		<div class="modal-dialog" role="document">
			<div class="modal-content">
				<div class="modal-header">
					<h5 class="modal-title" id="exampleModalLabel">Voucher Detail</h5>
					<button type="button" class="close" data-dismiss="modal" aria-label="Close">
						<span aria-hidden="true">&times;</span>
					</button>
				</div>
				<div class="modal-body">
					<div class="row form-group">
						<div class="col-sm-4">
							<label>Mã voucher</label>
						</div>
						<div class="col-sm-8">
							<input class="form-control" id="input-voucher">
						</div>
					</div>

					<div class="row form-group">
						<div class="col-sm-4">
							<label>Phần Trăm Giảm Giá</label>
						</div>
						<div class="col-sm-8">
							<input class="form-control" id="input-discount-percent">
						</div>
					</div>

					<div class="row form-group">
						<div class="col-sm-4">
							<label>Ghi Chú</label>
						</div>
						<div class="col-sm-8">
							<input class="form-control" id="input-ghi-chu">
						</div>
					</div>

					<div class="row form-group">
						<div class="col-sm-4">
							<label>Ngày Tạo</label>
						</div>
						<div class="col-sm-8">
							<input class="form-control" id="input-ngay-tao">
						</div>
					</div>

					<div class="row form-group">
						<div class="col-sm-4">
							<label>Ngày cập nhật</label>
						</div>
						<div class="col-sm-8">
							<input class="form-control" id="input-cap-nhat">
						</div>
					</div>
				</div>
				<div class="modal-footer">
					<button id="btn-delete" type="button" class="btn btn-danger">Xóa voucher</button>
					<button id="btn-update" type="button" class="btn btn-success">Cập nhật</button>
				</div>
			</div>
		</div>
	</div>

	<!-- Modal confirm delete -->
	<div class="modal fade" id="modal-confirm" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
		<div class="modal-dialog" role="document">
		  <div class="modal-content">
			<div class="modal-header">
			  <h5 class="modal-title" id="exampleModalLabel">bạn có chắc chắn muốn xóa tất cả voucher</h5>
			  <button type="button" class="close" data-dismiss="modal" aria-label="Close">
				<span aria-hidden="true">&times;</span>
			  </button>
			</div>
			<div class="modal-footer">
			  <button type="button" class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
			  <button id="btn-confirm" type="button" class="btn btn-warning">Xác nhận</button>
			</div>
		  </div>
		</div>
	  </div>
	<script>
		"use strict"
		/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
		var gTable = $("#user-table").DataTable({
			"columns": [
				{ "data": "id" },
				{ "data": "maVoucher" },
				{ "data": "phanTramGiamGia" },
				{ "data": "ghiChu" },
				{ "data": "ngayTao" },
				{ "data": "ngayCapNhat" },
			]
		});

		var gIdVoucher = "";
		/*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
		onPageLoading();

		// Thực thi sự kiện nhấn vào row
		$("#user-table").on("click", "tr", function () {
			onClickRowOnDataTable(this);
		});

		// Thực thi sự kiện nhấn nút update trong modal detail
		$("#btn-update").on("click", function() {
			onBtnUpdateClick();
		})

		// Thực thi sự kiện nhấn nút thêm mới voucher
		$("#btn-add").on("click", function() {
			onBtnAddNewVoucher();
		})

		// Thực thi sự kiện nhấn nút xóa voucher trong modal detail
		$("#btn-delete").on("click", function() {
			calApiToDeleteVoucherById();
		}) 
			
		// Thực thi sự kiện nhấn nút delete tất cả
		$("#btn-delete-all").on("click", function() {
			$("#modal-confirm").modal("show");
		});

		// Thực thi sự kiện nhấn nút xác nhận xóa tất cả trong modal confirm
		$("#btn-confirm").on("click", function() {
			calApiToDeleteVoucher();
			$("#modal-confirm").modal("hide");

		})

		/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
		function onPageLoading() {
			callApiToLoadListVoucher();
		}

		// Hàm xử lý sự kiện khi nhấn vào row bất kì
		function onClickRowOnDataTable(paramRow) {
			var vRowClickData = gTable.row(paramRow).data();
			gIdVoucher = vRowClickData.id;
			callApiToGetVoucherByID(vRowClickData.id);
			$("#modal-detail").modal("show");
		}

		// Hàm xử lý sự kiện khi nhấn vào nút cập nhật trong modal detail
		function onBtnUpdateClick() {
			var vVoucherUpdate = {
				maVoucher: "",
				phanTramGiamGia: "",
				ghiChu: "",
				ngayTao: "", 
				ngayCapNhat: ""
			}

			getUpdateVoucher(vVoucherUpdate);
			console.log(vVoucherUpdate);
			var vValidate = validateData(vVoucherUpdate);
			if(vValidate) {
				callApiToUpdateVoucher(vVoucherUpdate);
			}
		}
		
		
		// Hàm xử lý sự kiện thêm mới dữ liệu 
		function onBtnAddNewVoucher() {
			var vVoucherAdd = {
				maVoucher: "",
				phanTramGiamGia: "",
				ghiChu: "",
				ngayTao: "", 
				ngayCapNhat: ""
			}
			getDataVoucherAdd(vVoucherAdd);
			var vValidate = validateData(vVoucherAdd);
			if(vValidate) {
				callApiToCreateVoucher(vVoucherAdd)
			}
		}
		
		// Hàm xử lý sự kiện xóa dữ liệu trong modal
		
		
		/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
		// Hàm gọi API để lấy danh sách voucher ra datatable
		function callApiToLoadListVoucher() {
			$.ajax({
				url: "http://localhost:8080/api/vouchers",
				type: "GET",
				dataType: "json",
				success: function (res) {
					console.log(res);
					gTable.clear();
					gTable.rows.add(res);
					gTable.draw();
				},
				error: function (err) {
					console.log(err.response);
				}
			})
		}


		// Hàm gọi API để lấy thông tin Voucher thông qua ID
		function callApiToGetVoucherByID(paramId) {
			$.ajax({
				type: "GET",
				url: "http://localhost:8080/api/vouchers/" + paramId,
				success: function (paramRes) {
					console.log(paramRes);
					handleGetVoucherByIdSuccess(paramRes);
				},
				error: function (paramError) {
					console.log(paramError.status);
				}
			})
		}

		// Hàm xử lý sau khi gọi API lấy thông tin voucher thành công
		// Hiển thị thông tin trả về ra modal
		function handleGetVoucherByIdSuccess(paramResVoucher) {
			$("#input-voucher").val(paramResVoucher.maVoucher);
			$("#input-discount-percent").val(paramResVoucher.phanTramGiamGia);
			console.log(paramResVoucher.ghiChu);
			$("#input-ghi-chu").val(paramResVoucher.ghiChu);
			$("#input-ngay-tao").val(paramResVoucher.ngayTao);
			$("#input-cap-nhat").val(paramResVoucher.ngayCapNhat);
		}

		// Hàm get thông tin voucher sau khi chỉnh sửa
		function getUpdateVoucher(paramVoucherUpdate) {
			paramVoucherUpdate.maVoucher = $("#input-voucher").val();
			paramVoucherUpdate.phanTramGiamGia = $("#input-discount-percent").val();
			paramVoucherUpdate.ghiChu = $("#input-ghi-chu").val();
			paramVoucherUpdate.ngayTao = $("#input-ngay-tao").val();
			paramVoucherUpdate.ngayCapNhat = $("#input-cap-nhat").val();
		}

		// Hàm validate dữ liệu voucher
		function validateData(paramVoucher) {
			if(paramVoucher.maVoucher == "") {
				alert("Vui lòng nhập mã voucher");
				return false;
			}

			if(paramVoucher.phanTramGiamGia == "") {
				alert("Vui lòng nhập phần trăm giảm giá");
				return false;
			}

			if(paramVoucher.ghiChu == "") {
				alert("Vui lòng nhập ghi chú");
				return false;
			}
			return true;
		}

		// Hàm gọi API để cập nhật dữ liệu voucher
		function callApiToUpdateVoucher(paramVoucherUpdate) {
			$.ajax({
				type: "PUT",
				url: "http://localhost:8080/api/vouchers/" + gIdVoucher,
				contentType: "application/json",
				data: JSON.stringify(paramVoucherUpdate),
				success:function(paramRes) {
					alert("Cập nhập thành công!");
					$("#modal-detail").modal("hide");
					callApiToLoadListVoucher();
				},
				error: function(paramError) {
					console.log(paramError.status);
					alert("Cập nhập không thành công, vui lòng thử lại!");
					$("#modal-detail").modal("hide");
				}

			})
		}
	
		// Hàm lấy thông tin voucher thêm mới
		function getDataVoucherAdd(paramVoucherAdd) {
			paramVoucherAdd.maVoucher = $("#input-voucher-code").val();
			paramVoucherAdd.phanTramGiamGia = $("#input-discount").val();
			paramVoucherAdd.ghiChu = $("#input-note").val();
			paramVoucherAdd.ngayTao = $("#input-createDate").val();
			paramVoucherAdd.ngayCapNhat = $("#input-updateDate").val();
		}
		
		// Hàm gọi API để thêm mới dữ liệu voucher
		function callApiToCreateVoucher(paramDataVoucherAdd) {
			$.ajax({
				type: "POST",
				url: "http://localhost:8080/api/vouchers/",
				contentType: "application/json",
				data: JSON.stringify(paramDataVoucherAdd),
				success:function(paramRes) {
					alert("Thêm mới thành công!");
					callApiToLoadListVoucher();
				},
				error: function(paramError) {
					console.log(paramError.status);
					alert("Thêm mới không thành công, vui lòng thử lại!");
				}

			})
		}
	
	
		// Hàm gọi API để xóa thông tin voucher thông qua id
		function calApiToDeleteVoucherById() {
			$.ajax({
				type: "DELETE",
				url: "http://localhost:8080/api/vouchers/" + gIdVoucher,
				success:function(paramRes) {
					alert("Xóa dữ liệu thành công!");
					$("#modal-detail").modal("hide");
					callApiToLoadListVoucher();
				},
				error: function(paramError) {
					console.log(paramError.status);
					alert("Xóa không thành công, vui lòng thử lại!");
					$("#modal-detail").modal("hide");
				}

			})
		}

		// Hàm gọi API để xóa tất cả voucher
		function calApiToDeleteVoucher() {
			$.ajax({
				type: "DELETE",
				url: "http://localhost:8080/api/vouchers/",
				success:function(paramRes) {
					alert("Xóa tất cả dữ liệu thành công!");
					$("#modal-confirm").modal("hide");
					callApiToLoadListVoucher();
				},
				error: function(paramError) {
					console.log(paramError.status);
					alert("Xóa dữ liệu không thành công, vui lòng thử lại!");
					$("#modal-confirm").modal("hide");
				}

			})
		}
	</script>
</body>

</html>